package wad.jobs;

import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

@Controller
public class JobController {

    @Autowired
    private JobRepository jobRepository;

    @RequestMapping(value = "/", method = RequestMethod.GET)
    public String list(Model model) {
        /*
         * Note: this approach is ok at this point as we have not yet delved 
         * deeper into how database queries are constructed. In reality, you
         * likely would want to limit the result set size.
         */
        List<Job> jobs = jobRepository.findAll();
        model.addAttribute("jobs", jobs.stream().filter(j -> !j.getDone()).collect(Collectors.toList()));
        model.addAttribute("pastJobs", jobs.stream().filter(j -> j.getDone()).collect(Collectors.toList()));

        return "index";
    }

    @RequestMapping(value = "/", method = RequestMethod.POST)
    public String add(@RequestParam String name) {
        if (!name.trim().isEmpty()) {
            jobRepository.save(new Job(name));
        }

        return "redirect:/";
    }

    @RequestMapping(value = "/jobs/{id}", method = RequestMethod.POST)
    public String setDone(@PathVariable Long id) {
        Optional<Job> jobOpt = jobRepository.findById(id);
        if (jobOpt.isPresent()) {
            Job job = jobOpt.get();
            job.setDone(true);
            jobRepository.save(job);
        }

        return "redirect:/";
    }
}
